Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkEncodedGradientShader Class Reference

`#include <vtkEncodedGradientShader.h>`

Inheritance diagram for vtkEncodedGradientShader:

[legend]
Collaboration diagram for vtkEncodedGradientShader:

[legend]
List of all members.

## Detailed Description

Compute shading tables for encoded normals.

Date:
  2002/08/22 18:39:30

Revision:
  1.24

vtkEncodedGradientShader computes shading tables for encoded normals that indicates the amount of diffuse and specular illumination that is received from all light sources at a surface location with that normal. For diffuse illumination this is accurate, but for specular illumination it is approximate for perspective projections since the center view direction is always used as the view direction. Since the shading table is dependent on the volume (for the transformation that must be applied to the normals to put them into world coordinates) there is a shading table per volume. This is necessary because multiple volumes can share a volume mapper.

Created by:
  - Avila, Lisa

CVS contributions (if > 5%):
  - Avila, Lisa (85%)
  - Lorensen, Bill (5%)

CVS logs (CVSweb):
  - .`cxx` (`/Rendering/vtkEncodedGradientShader.cxx)`
  - .`h` (`/Rendering/vtkEncodedGradientShader.h)`

Definition at line 58 of file vtkEncodedGradientShader.h.

## Public Types
typedef vtkObject | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
virtual void | SetZeroNormalDiffuseIntensity (float)
virtual float | GetZeroNormalDiffuseIntensity ()
virtual void | SetZeroNormalSpecularIntensity (float)
virtual float | GetZeroNormalSpecularIntensity ()
void | UpdateShadingTable (vtkRenderer *ren, vtkVolume *vol, vtkEncodedGradientEstimator *gradest)
float * | GetRedDiffuseShadingTable (vtkVolume *vol)
float * | GetGreenDiffuseShadingTable (vtkVolume *vol)
float * | GetBlueDiffuseShadingTable (vtkVolume *vol)
float * | GetRedSpecularShadingTable (vtkVolume *vol)
float * | GetGreenSpecularShadingTable (vtkVolume *vol)
float * | GetBlueSpecularShadingTable (vtkVolume *vol)
## Static Public Methods
vtkEncodedGradientShader * | New ()
int | IsTypeOf (const char *type)
vtkEncodedGradientShader * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkEncodedGradientShader ()
| ~vtkEncodedGradientShader ()
void | BuildShadingTable (int index, float lightDirection[3], float lightColor[3], float lightIntensity, float viewDirection[3], float material[4], int twoSided, vtkEncodedGradientEstimator *gradest, int updateFlag)
## Protected Attributes
float * | ShadingTable [VTK_MAX_SHADING_TABLES][6]
vtkVolume * | ShadingTableVolume [VTK_MAX_SHADING_TABLES]
int | ShadingTableSize [VTK_MAX_SHADING_TABLES]
float | ZeroNormalDiffuseIntensity
float | ZeroNormalSpecularIntensity

## Member Typedef Documentation

typedef vtkObject vtkEncodedGradientShader::Superclass

| Reimplemented from vtkObject. Definition at line 62 of file vtkEncodedGradientShader.h.

## Constructor & Destructor Documentation

vtkEncodedGradientShader::vtkEncodedGradientShader | ( |  | ) | `[protected]`

vtkEncodedGradientShader::~vtkEncodedGradientShader | ( |  | ) | `[protected]`

## Member Function Documentation

vtkEncodedGradientShader* vtkEncodedGradientShader::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual const char* vtkEncodedGradientShader::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkObject.

int vtkEncodedGradientShader::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject.

virtual int vtkEncodedGradientShader::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject.

vtkEncodedGradientShader* vtkEncodedGradientShader::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkObject.

void vtkEncodedGradientShader::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Print the vtkEncodedGradientShader Reimplemented from vtkObject.

virtual void vtkEncodedGradientShader::SetZeroNormalDiffuseIntensity | ( | float |  | ) | `[virtual]`

| Set / Get the intensity diffuse / specular light used for the zero normals.

virtual float vtkEncodedGradientShader::GetZeroNormalDiffuseIntensity | ( |  | ) | `[virtual]`

| Set / Get the intensity diffuse / specular light used for the zero normals.

virtual void vtkEncodedGradientShader::SetZeroNormalSpecularIntensity | ( | float |  | ) | `[virtual]`

| Set / Get the intensity diffuse / specular light used for the zero normals.

virtual float vtkEncodedGradientShader::GetZeroNormalSpecularIntensity | ( |  | ) | `[virtual]`

| Set / Get the intensity diffuse / specular light used for the zero normals.

void vtkEncodedGradientShader::UpdateShadingTable | ( | vtkRenderer * | ren,
|  | vtkVolume * | vol,
|  | vtkEncodedGradientEstimator * | gradest
| ) |

| Cause the shading table to be updated

float* vtkEncodedGradientShader::GetRedDiffuseShadingTable | ( | vtkVolume * | vol | ) |

| Get the red/green/blue shading table.

float* vtkEncodedGradientShader::GetGreenDiffuseShadingTable | ( | vtkVolume * | vol | ) |

| Get the red/green/blue shading table.

float* vtkEncodedGradientShader::GetBlueDiffuseShadingTable | ( | vtkVolume * | vol | ) |

| Get the red/green/blue shading table.

float* vtkEncodedGradientShader::GetRedSpecularShadingTable | ( | vtkVolume * | vol | ) |

| Get the red/green/blue shading table.

float* vtkEncodedGradientShader::GetGreenSpecularShadingTable | ( | vtkVolume * | vol | ) |

| Get the red/green/blue shading table.

float* vtkEncodedGradientShader::GetBlueSpecularShadingTable | ( | vtkVolume * | vol | ) |

| Get the red/green/blue shading table.

void vtkEncodedGradientShader::BuildShadingTable | ( | int | index,
|  | float | lightDirection[3],
|  | float | lightColor[3],
|  | float | lightIntensity,
|  | float | viewDirection[3],
|  | float | material[4],
|  | int | twoSided,
|  | vtkEncodedGradientEstimator * | gradest,
|  | int | updateFlag
| ) | `[protected]`

| Build a shading table for a light with the specified direction, and color for an object of the specified material properties. material[0] = ambient, material[1] = diffuse, material[2] = specular and material[3] = specular exponent. If the ambient flag is 1, then ambient illumination is added. If not, then this means we are calculating the "other side" of two sided lighting, so no ambient intensity is added in. If the update flag is 0, the shading table is overwritten with these new shading values. If the updateFlag is 1, then the computed light contribution is added to the current shading table values. There is one shading table per volume, and the index value indicated which index table should be used. It is computed in the UpdateShadingTable method.

## Member Data Documentation

float* vtkEncodedGradientShader::ShadingTable[VTK_MAX_SHADING_TABLES][6]`[protected]`

| Definition at line 125 of file vtkEncodedGradientShader.h.

vtkVolume* vtkEncodedGradientShader::ShadingTableVolume[VTK_MAX_SHADING_TABLES]`[protected]`

| Definition at line 126 of file vtkEncodedGradientShader.h.

int vtkEncodedGradientShader::ShadingTableSize[VTK_MAX_SHADING_TABLES]`[protected]`

| Definition at line 127 of file vtkEncodedGradientShader.h.

float vtkEncodedGradientShader::ZeroNormalDiffuseIntensity`[protected]`

| Definition at line 131 of file vtkEncodedGradientShader.h.

float vtkEncodedGradientShader::ZeroNormalSpecularIntensity`[protected]`

| Definition at line 132 of file vtkEncodedGradientShader.h.

The documentation for this class was generated from the following file:

- Rendering/vtkEncodedGradientShader.h